<template>
  <div :id="props.id" class="mb-15">
    <div class="post-header">
      <div class="post-avatar" :style="`background-image: url(${props.user.avatar})`" />
      <div class="post-user">
        <h3>{{ props.user.name }}</h3>
        <span>{{ friendlyTimestamp }}</span>
      </div>
      <div v-if="admin" class="actions-row">
        <div @click="deletePost">
          <svg xmlns="http://www.w3.org/2000/svg" height="1em" viewBox="0 0 448 512">
            <path
              d="M135.2 17.7L128 32H32C14.3 32 0 46.3 0 64S14.3 96 32 96H416c17.7 0 32-14.3 32-32s-14.3-32-32-32H320l-7.2-14.3C307.4 6.8 296.3 0 284.2 0H163.8c-12.1 0-23.2 6.8-28.6 17.7zM416 128H32L53.2 467c1.6 25.3 22.6 45 47.9 45H346.9c25.3 0 46.3-19.7 47.9-45L416 128z"
            />
          </svg>
        </div>
      </div>
    </div>
    <ThePostMedia :items="props.post.media" :username="props.user.name" />
  </div>
</template>

<script setup>
import { friendlyDate } from '@/scripts/dates'
import { computed, onMounted, defineEmits } from 'vue'
import { db } from '@/firebase'
import { doc, deleteDoc } from 'firebase/firestore'
import ThePostMedia from '@/components/ThePostMedia.vue'

const props = defineProps({
  user: Object,
  post: Object,
  now: Date,
  admin: Boolean,
  id: String
})

const friendlyTimestamp = computed({
  get() {
    return friendlyDate(props.post.timestamp?.toDate(), props.now)
  }
})

const deletePost = async () => {
  if (!props.admin) {
    return
  }

  if (confirm('Sei sicuro di voler eliminare il post?') == true) {
    await deleteDoc(doc(db, 'posts', props.post.id))
  }
}

const emit = defineEmits(['intersecting'])

onMounted(() => {
  const observer = new IntersectionObserver((entries) => {
    entries.forEach((entry) => {
      if (entry.isIntersecting) {
        emit('intersecting', parseInt(entry?.target?.id?.split('-')?.[1]))
      }
    })
  })

  observer.observe(document.getElementById(props.id))
})
</script>

<style lang="less" scoped>
.post-header {
  display: flex;
  justify-content: flex-start;
  margin-bottom: 5px;

  .post-avatar {
    width: 36px;
    height: 36px;
    border-radius: 50px;
    border: 2px solid var(--color-border-heading);
    background-size: cover;
  }

  .post-user {
    margin-left: 8px;

    h3 {
      font-weight: bold;
      font-size: 18px;
    }

    span {
      margin-top: -5px;
      display: block;
      font-size: 14px;
    }
  }
}

.actions-row {
  flex: 1;
  align-items: center;
  display: flex;
  justify-content: flex-end;

  svg {
    width: 20px;
    height: 20px;

    path {
      fill: var(--color-text);
    }
  }
}
</style>
